## toybox 0.8.6+dfsg

=== Makefile ===
# Makefile for toybox.
# Copyright 2006 Rob Landley <rob@landley.net>

# If people set these on the make command line, use 'em
# Note that CC defaults to "cc" so the one in configure doesn't get
# used when scripts/make.sh and care called through "make".

HOSTCC?=cc

export CROSS_COMPILE CFLAGS OPTIMIZE LDOPTIMIZE CC HOSTCC V STRIP

all: toybox

KCONFIG_CONFIG ?= .config

toybox generated/unstripped/toybox: $(KCONFIG_CONFIG) *.[ch] lib/*.[ch] toys/*/*.c scripts/*.sh Config.in
	scripts/make.sh

.PHONY: clean distclean baseline bloatcheck install install_flat \
	uninstall uninstall_flat tests help change \
	list list_working list_pending root run_root
.SUFFIXES: # Disable legacy behavior

include kconfig/Makefile
-include .singlemake

$(KCONFIG_CONFIG): $(KCONFIG_TOP)
	@if [ -e "$(KCONFIG_CONFIG)" ]; then make silentoldconfig; \
	else echo "Not configured (run 'make defconfig' or 'make menuconfig')";\
	exit 1; fi

$(KCONFIG_TOP): generated/Config.in generated/Config.probed
generated/Config.probed: generated/Config.in
generated/Config.in: toys/*/*.c scripts/genconfig.sh
	scripts/genconfig.sh

# Development targets
baseline: generated/unstripped/toybox
	@cp generated/unstripped/toybox generated/unstripped/toybox_old

bloatcheck: generated/unstripped/toybox_old generated/unstripped/toybox
	@scripts/bloatcheck generated/unstripped/toybox_old generated/unstripped/toybox

install_flat:
	scripts/install.sh --symlink --force

install_airlock:
	scripts/install.sh --symlink --force --airlock

install:
	scripts/install.sh --long --symlink --force

uninstall_flat:
	scripts/install.sh --uninstall

uninstall:
	scripts/install.sh --long --uninstall

change:
	scripts/change.sh

root_clean:
	@rm -rf root
	@echo root cleaned

clean::
	@chmod -fR 700 generated || true
	@rm -rf toybox generated change .singleconfig*
	@echo cleaned

# If singlemake was in generated/ "make clean; make test_ls" wouldn't work.
distclean: clean root_clean
	@rm -f toybox* .config* .singlemake
	@echo removed .config

tests:
	scripts/test.sh

root:
	scripts/mkroot.sh $(MAKEFLAGS)

run_root:
	cd root/"$${CROSS:-host}" && ./qemu-*.sh

help::
	@cat scripts/help.txt

=== kconfig/Makefile ===
# ===========================================================================
# Kernel configuration targets
# These targets are used from top-level makefile

KCONFIG_TOP = Config.in
KCONFIG_PROJECT = ToyBox
obj = ./kconfig
PHONY += clean help oldconfig menuconfig config silentoldconfig \
	randconfig allyesconfig allnoconfig allmodconfig defconfig

menuconfig: $(obj)/mconf $(KCONFIG_TOP)
	$< $(KCONFIG_TOP)

config: $(obj)/conf $(KCONFIG_TOP)
	$< $(KCONFIG_TOP)

oldconfig: $(obj)/conf $(KCONFIG_TOP)
	$< -o $(KCONFIG_TOP)

silentoldconfig: $(obj)/conf $(KCONFIG_TOP)
	yes '' | $< -o $(KCONFIG_TOP) > /dev/null

randconfig: $(obj)/conf $(KCONFIG_TOP)
	$< -r $(KCONFIG_TOP) > /dev/null

allyesconfig: $(obj)/conf $(KCONFIG_TOP)
	$< -y $(KCONFIG_TOP) > /dev/null

allnoconfig: $(obj)/conf $(KCONFIG_TOP)
	$< -n $(KCONFIG_TOP) > /dev/null

KCONFIG_ALLCONFIG ?= /dev/null
defconfig: $(obj)/conf $(KCONFIG_TOP)
	$< -D $(KCONFIG_ALLCONFIG) $(KCONFIG_TOP) > /dev/null

macos_defconfig: $(obj)/conf $(KCONFIG_TOP)
	KCONFIG_ALLCONFIG=$(obj)/macos_miniconfig $< -n $(KCONFIG_TOP) > /dev/null

bsd_defconfig: $(obj)/conf $(KCONFIG_TOP)
	KCONFIG_ALLCONFIG=$(obj)/freebsd_miniconfig $< -n $(KCONFIG_TOP) > /dev/null

# Help text used by make help
help::
	@echo  '  config	  - Update current config utilising a line-oriented program'
	@echo  '  menuconfig	  - Update current config utilising a menu based program'
	@echo  '  oldconfig	  - Update current config utilising a provided .config as base'
	@echo  '  silentoldconfig - Same as oldconfig, but quietly'
	@echo  '  randconfig	  - New config with random answer to all options'
	@echo  '  defconfig	  - New config with default answer to all options'
	@echo  '                    This is the maximum sane configuration.'
	@echo  '  allyesconfig	  - New config where all options are accepted with yes'
	@echo  "                    This may not actually compile, it's a starting point"
	@echo  '                    for further configuration (probably with menuconfig)'
	@echo  '  allnoconfig	  - New config where all options are answered with no'
	@echo  '                    (NOP binary, starting point for further configuration)'
	@echo  '  macos_defconfig - Select commands known to build on macosx'
	@echo  '  bsd_defconfig   - Select commands known to build on freebsd'

# Cheesy build

SHIPPED = kconfig/zconf.tab.c kconfig/lex.zconf.c kconfig/zconf.hash.c

%.c: %.c_shipped
	@ln -s $(notdir $<) $@

gen_config.h: .config

kconfig/mconf: $(SHIPPED)
	$(HOSTCC) -o $@ kconfig/mconf.c kconfig/zconf.tab.c \
		kconfig/lxdialog/*.c -lcurses -DCURSES_LOC="<ncurses.h>" \
		-DKBUILD_NO_NLS=1 -DPROJECT_NAME=\"$(KCONFIG_PROJECT)\"

kconfig/conf: $(SHIPPED)
	$(HOSTCC) -o $@ kconfig/conf.c kconfig/zconf.tab.c -DKBUILD_NO_NLS=1 \
		-DPROJECT_NAME=\"$(KCONFIG_PROJECT)\"

clean::
	@rm -f $(wildcard kconfig/*zconf*.c) kconfig/conf kconfig/mconf

=== debian/changelog ===
toybox (0.8.6+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #968162)

 -- Antoni Villalonga <antoni@friki.cat>  Wed, 22 Dec 2021 07:01:37 +0000

=== debian/control ===
Source: toybox
Section: utils
Priority: optional
Maintainer: Antoni Villalonga <antoni@friki.cat>
Build-Depends: debhelper-compat (= 13),
#               libssl-dev,
#               zlib1g-dev,
               help2man,
               locales-all,
Standards-Version: 4.6.0.1
Homepage: https://www.landley.net/toybox/
Vcs-Browser: https://salsa.debian.org/debian/toybox
Vcs-Git: https://salsa.debian.org/debian/toybox.git
Rules-Requires-Root: no

Package: toybox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: BSD-licensed Linux command line utilities
 Toybox combines common Linux command line utilities together into a single
 BSD-licensed executable that's simple, small, fast, reasonably
 standards-compliant, and powerful enough to turn Android into a development
 environment.

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	# README:
	# The maximum sane configuration is "make defconfig": allyesconfig isn't
	CFLAGS="$(CFLAGS) $(CPPFLAGS) $(LDFLAGS)" make defconfig

	# Go for insanely overpowered toys!
	# allyesconfig add build-depends: libssl-dev zlib1g-dev
	#CFLAGS="$(CFLAGS) $(CPPFLAGS) $(LDFLAGS)" make allyesconfig

	# Hardening and such FLAGS
	echo $(CFLAGS) > generated/cflags
	echo $(CPPFLAGS) >> generated/cflags

override_dh_auto_install:
	# We need relative paths
	PREFIX="." make install

override_dh_installman:
	# Automated manpages generation
	help2man -n 'Toybox - BSD-licensed Linux command line utilities' ./toybox > toybox.1

	dh_installman

## toybox 0.8.8%2Bdfsg

=== debian/changelog ===
toybox (0.8.8+dfsg-1) unstable; urgency=medium

  * New upstream version 0.8.8+dfsg
  * Bump Standards-Version to 4.6.1.0 (no changes)
  * Refresh patches
  * New patch spelling.patch
  * Wrap fstype for initramfs-tools. Closes: #1013074
  * Remove debian/toybox.lintian-overrides

 -- Antoni Villalonga <antoni@friki.cat>  Thu, 18 Aug 2022 22:44:38 +0000

toybox (0.8.6+dfsg-3) unstable; urgency=medium

  * Fix binary path on initramfs hook.
    Thanks to Axel Beckert for reporting and patch (Closes: #1006557)

 -- Antoni Villalonga <antoni@friki.cat>  Sun, 27 Feb 2022 23:39:07 +0000

toybox (0.8.6+dfsg-2) unstable; urgency=medium

  * New patch debianize-paths.patch
  * Add initramfs hooks

 -- Antoni Villalonga <antoni@friki.cat>  Sat, 26 Feb 2022 00:17:16 +0000

## toybox 0.8.8+dfsg

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 # If people set these on the make command line, use 'em
 # Note that CC defaults to "cc" so the one in configure doesn't get
-# used when scripts/make.sh and care called through "make".
+# used when scripts/make.sh and such called through "make".
 
 HOSTCC?=cc
 
@@ -18,7 +18,7 @@
 
 .PHONY: clean distclean baseline bloatcheck install install_flat \
 	uninstall uninstall_flat tests help change \
-	list list_working list_pending root run_root
+	list list_example list_pending root run_root
 .SUFFIXES: # Disable legacy behavior
 
 include kconfig/Makefile
@@ -41,13 +41,13 @@
 bloatcheck: generated/unstripped/toybox_old generated/unstripped/toybox
 	@scripts/bloatcheck generated/unstripped/toybox_old generated/unstripped/toybox
 
-install_flat:
+install_flat: toybox
 	scripts/install.sh --symlink --force
 
-install_airlock:
+install_airlock: toybox
 	scripts/install.sh --symlink --force --airlock
 
-install:
+install: toybox
 	scripts/install.sh --long --symlink --force
 
 uninstall_flat:
@@ -65,7 +65,7 @@
 
 clean::
 	@chmod -fR 700 generated || true
-	@rm -rf toybox generated change .singleconfig*
+	@rm -rf toybox generated change install .singleconfig*
 	@echo cleaned
 
 # If singlemake was in generated/ "make clean; make test_ls" wouldn't work.
@@ -80,7 +80,7 @@
 	scripts/mkroot.sh $(MAKEFLAGS)
 
 run_root:
-	cd root/"$${CROSS:-host}" && ./qemu-*.sh
+	cd root/"$${CROSS:-host}" && ./run-qemu.sh
 
 help::
 	@cat scripts/help.txt

=== debian/changelog ===
toybox (0.8.8+dfsg-2) unstable; urgency=medium

  * New patch timeout.patch. Closes: #1019392
  * New patch set-pathmax-default.patch

 -- Antoni Villalonga <antoni@friki.cat>  Sun, 11 Sep 2022 22:27:42 +0000

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 #               zlib1g-dev,
                help2man,
                locales-all,
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1.0
 Homepage: https://www.landley.net/toybox/
 Vcs-Browser: https://salsa.debian.org/debian/toybox
 Vcs-Git: https://salsa.debian.org/debian/toybox.git

## toybox 0.8.9%2Bdfsg

=== kconfig/Makefile ===
--- 
+++ 
@@ -39,6 +39,8 @@
 bsd_defconfig: $(obj)/conf $(KCONFIG_TOP)
 	KCONFIG_ALLCONFIG=$(obj)/freebsd_miniconfig $< -n $(KCONFIG_TOP) > /dev/null
 
+android_defconfig: $(obj)/conf $(KCONFIG_TOP)
+	KCONFIG_ALLCONFIG=$(obj)/android_miniconfig $< -n $(KCONFIG_TOP) > /dev/null
 # Help text used by make help
 help::
 	@echo  '  config	  - Update current config utilising a line-oriented program'
@@ -55,6 +57,7 @@
 	@echo  '                    (NOP binary, starting point for further configuration)'
 	@echo  '  macos_defconfig - Select commands known to build on macosx'
 	@echo  '  bsd_defconfig   - Select commands known to build on freebsd'
+	@echo  '  android_defconfig - Select commands available on android'
 
 # Cheesy build

=== debian/changelog ===
toybox (0.8.9+dfsg-1.1ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable (LP: #2098577). Remaining changes:
    - Clear V from the environment, the package fails to build if set.

 -- Matthieu Clemenceau <matthieu.clemenceau@canonical.com>  Sat, 15 Feb 2025 21:17:57 +0000

toybox (0.8.9+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Install into /usr. (Closes: #1073638)

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 08 Jul 2024 01:13:29 +0200

toybox (0.8.9+dfsg-1ubuntu1) lunar; urgency=medium

  * Clear V from the environment, the package fails to build if set.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 12 Apr 2023 01:58:55 +0000

toybox (0.8.9+dfsg-1) unstable; urgency=medium

  * New upstream version 0.8.9+dfsg
  * Bump Standards-Version to 4.6.2 (no changes)
  * Drop patch set-pathmax-default.patch
  * Refresh patches
  * Autopkgtest: Update toybox-selftest

 -- Antoni Villalonga <antoni@friki.cat>  Sat, 18 Feb 2023 19:07:34 +0000

## toybox 0.8.9+dfsg

=== Makefile ===
--- 
+++ 
@@ -73,7 +73,7 @@
 	@rm -f toybox* .config* .singlemake
 	@echo removed .config
 
-tests:
+tests: toybox
 	scripts/test.sh
 
 root:

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 #               zlib1g-dev,
                help2man,
                locales-all,
-Standards-Version: 4.6.1.0
+Standards-Version: 4.6.2
 Homepage: https://www.landley.net/toybox/
 Vcs-Browser: https://salsa.debian.org/debian/toybox
 Vcs-Git: https://salsa.debian.org/debian/toybox.git

=== debian/watch ===
version=4

opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//,repacksuffix=+dfsg \
  https://www.landley.net/toybox/downloads/ \
  toybox-([\d\.]+)\.tar\.gz debian uupdate
